package com.cy.mybatis.bean;

import java.sql.Blob;
import java.sql.Clob;
import java.sql.SQLException;
import java.time.LocalDateTime;
import java.util.Arrays;

public class UserBean {

	private int id;
	private String username;
	private byte[] password;
	private boolean sex;
	private int sex2;
	private LocalDateTime birthday;

	public boolean getSex() {
		return sex;
	}

	public void setSex(boolean sex) {
		this.sex = sex;
	}
	
	public UserBean() {
	}

	public UserBean(int id, String username, byte[] password) {
		super();
		this.id = id;
		this.username = username;
		this.password = password;
	}
	
	public UserBean(String username, byte[] password, boolean sex) {
		super();
		this.username = username;
		this.password = password;
		this.sex = sex;
	}

	public UserBean(int id, String username, byte[] password, boolean sex, LocalDateTime birthday) {
		this.id = id;
		this.username = username;
		this.password = password;
		this.sex = sex;
		this.birthday = birthday;
	}
	
	public UserBean(Integer id, Clob username, Blob password, Boolean sex) throws SQLException {
		this.id = id;
		this.username = username.getSubString(1, (int) username.length());
		this.password = password.getBytes(1, (int) password.length());
		this.sex = sex;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public String getUsername() {
		return username;
	}

	public void setUsername(String username) {
		this.username = username;
	}

	public byte[] getPassword() {
		return password;
	}

	public void setPassword(byte[] password) {
		this.password = password;
	}
	
	public int getSex2() {
		return sex2;
	}

	public void setSex2(int sex2) {
		this.sex2 = sex2;
	}

	public LocalDateTime getBirthday() {
		return birthday;
	}

	public void setBirthday(LocalDateTime birthday) {
		this.birthday = birthday;
	}

	@Override
	public String toString() {
		return "UserBean [id=" + id + ", username=" + username + ", password=" + Arrays.toString(password) + ", sex="
				+ sex + ", sex2=" + sex2 + ", birthday=" + birthday + "]";
	}


}
