package com.cy.mybatis.service;

import java.io.IOException;
import java.math.BigDecimal;
import java.sql.Clob;
import java.sql.Date;
import java.sql.ResultSet;
import java.sql.RowId;
import java.sql.SQLException;
import java.time.LocalDateTime;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.ibatis.io.Resources;
import org.apache.ibatis.jdbc.ScriptRunner;
import org.apache.ibatis.session.SqlSession;

import com.cy.mybatis.bean.UserBean;
import com.cy.mybatis.tool.DBTool;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.cy.mybatis.mapper.CallMapper;
import com.cy.mybatis.mapper.OtherMapper;
import com.cy.mybatis.mapper.UserMapper;

public class UserService {

	//create table t_user(id serial primary key,username clob,password clob,sex boolean);
	public static void main(String[] args) throws SQLException, IOException {
		createTable();
//		for (int i = 0; i < 20; i++) {
//			insertUser();
//		}
		insertUser();
//		selectUserByName();
//		selectUserById();
		test();
		updateUser();
        selectAllUser();
//        deleteUser();
//		
//		callProcedure();
//		callFunction();
//        getName();
//		testSelectT();
//		getPerson("ES");
//        getTest();
//		executeSql();
		
//		testSelectInterval();
	}
	
	public static void executeSql() throws IOException {
		SqlSession session = DBTool.getSession();
		ScriptRunner runner = new ScriptRunner(session.getConnection());
//		runner.setSendFullScript(true);
		runner.setDelimiter(";;");
		runner.runScript(Resources.getResourceAsReader("init.sql"));
	}
	
	public static void testSelectT() {
		SqlSession session = DBTool.getSession();
		OtherMapper mapper = session.getMapper(OtherMapper.class);
		
		PageHelper.startPage(1, 5, "createDate desc");
		List<Map<String, Object>> list = mapper.selectT();
		PageInfo<Map<String, Object>> page = new PageInfo<Map<String, Object>>(list);
		System.out.println("" + page.getTotal());
		System.out.println("ǰҳѯ¼" + page.getList().size());
		System.out.println("ǰҳ룺" + page.getPageNum());
		System.out.println("ÿҳʾ" + page.getPageSize());
		System.out.println("ҳ" + page.getPages());
		System.out.println("Page" + page.getPageNum() + ":" + page.getList().toString());
	}
	
	public static void testSelectInterval() {
		SqlSession session = DBTool.getSession();
		OtherMapper mapper = session.getMapper(OtherMapper.class);
		Date date = new Date(System.currentTimeMillis());
		Map<String, Object> map = mapper.selectInterval(date);
	}

	
	public static void createTable() {
		SqlSession session = DBTool.getSession();
		UserMapper mapper = session.getMapper(UserMapper.class);
		try {
			String sql = "create table t_user(id serial primary key,name clob,password bytea,sex boolean,sex2 int,birthday timestamp)";
			mapper.dropTable("t_user");
			mapper.createTable(sql);
//			mapper.createTable("insert into t_user(name,password,sex,sex2,birthday) values(null,null,'t',1,'2020-02-02 12:12:12')");
//			mapper.createTable("insert into zy_gs_res(datatime,name,id,code,port,contactor,phone,brand,objName,desc_,version_,ip,category) values('20210628172935','172.17.167.4(F 0/8) - 172.17.161.80(Intel(R) 82579LM Gigabit Network Connection\0)','b99b0227-dfb5-6abc-2444-7648c6d14a11','b99b0227-dfb5-6abc-2444-7648c6d14a11','null','null','null','null','null','null','null','','LINK')");
			session.commit();
		} catch (Exception e) {
			e.printStackTrace();
			session.rollback();
		}
	}

	public static void test() {
		SqlSession session = DBTool.getSession();
		UserMapper mapper = session.getMapper(UserMapper.class);
		
		PageHelper.startPage(1, 5);
		ArrayList<UserBean> list = mapper.getUserList();
		PageInfo<UserBean> page = new PageInfo<UserBean>(list);
		System.out.println("" + page.getTotal());
		System.out.println("ǰҳѯ¼" + page.getList().size());
		System.out.println("ǰҳ룺" + page.getPageNum());
		System.out.println("ÿҳʾ" + page.getPageSize());
		System.out.println("ҳ" + page.getPages());
	}

	/**
	 * û
	 * 
	 * @throws SQLException
	 */
	private static void insertUser() throws SQLException {
		SqlSession session = DBTool.getSession();
		UserMapper mapper = session.getMapper(UserMapper.class);
//		UserBean user = new UserBean("Mary", "1314520".getBytes(), true);
		try {
			LocalDateTime ldt = LocalDateTime.now();
			mapper.insertUser("Mary", "1314520".getBytes(), true, 0, ldt);
//			mapper.insertUser(user);
//			System.out.println(user.getId());
//			mapper.insertUser(user);
//			System.out.println(user.getId());
//			mapper.insertUser(user);
//			System.out.println(user.getId());
			session.commit();
		} catch (Exception e) {
			e.printStackTrace();
			session.rollback();
		}
	}
	
	private static void updateUser() throws SQLException {
		SqlSession session = DBTool.getSession();
		UserMapper mapper = session.getMapper(UserMapper.class);
		UserBean user = new UserBean(1, "John", "13145210".getBytes());
		UserBean user2 = new UserBean(2, "John", "13145210".getBytes());
		try {
			List<UserBean> list = new ArrayList<>();
			list.add(user);
			list.add(user2);
			mapper.updateUser(list);
			session.commit();
		} catch (Exception e) {
			e.printStackTrace();
			session.rollback();
		}
	}

	/**
	 * ɾû
	 */
	private static void deleteUser() {
		SqlSession session = DBTool.getSession();
		UserMapper mapper = session.getMapper(UserMapper.class);
		try {
			mapper.deleteUser(1);
			session.commit();
		} catch (Exception e) {
			e.printStackTrace();
			session.rollback();
		}
	}

	/**
	 * idѯû
	 */
	private static void selectUserById() {
		SqlSession session = DBTool.getSession();
		UserMapper mapper = session.getMapper(UserMapper.class);
		try {
			UserBean user = mapper.selectUserById(1);
			System.out.println(user.toString());
			session.commit();
		} catch (Exception e) {
			e.printStackTrace();
			session.rollback();
		}
	}

	
	private static void selectUserByName() {
		SqlSession session = DBTool.getSession();
		UserMapper mapper = session.getMapper(UserMapper.class);
		try {
			Map<String, Object> map = new HashMap<String, Object>();
			map.put("name", "Mary");
			map.put("offset2", 10);
			map.put("limit", 10);
			UserBean user = mapper.selectUserByName(map);
			System.out.println(user.toString());
			session.commit();
		} catch (Exception e) {
			e.printStackTrace();
			session.rollback();
		}
	}

	/**
	 * ѯеû
	 */
	private static void selectAllUser() {
		SqlSession session = DBTool.getSession();
		UserMapper mapper = session.getMapper(UserMapper.class);
		try {
			Map<String, Object> map = new HashMap<String, Object>();
			map.put("offset", 10);
			map.put("limit", 10);
			List<Map<String, Object>> user = mapper.selectAllUser(map);
			System.out.println(user.toString());
			session.commit();
		} catch (Exception e) {
			e.printStackTrace();
			session.rollback();
		}
	}

	private static void callProcedure() {
		SqlSession session = DBTool.getSession();
		CallMapper mapper = session.getMapper(CallMapper.class);
		try {
			Map<String, Object> map = new HashMap<String, Object>();
			map.put("a", 1);
			map.put("b", new BigDecimal(3));
			map.put("c", new BigDecimal(0));
			map.put("d", new BigDecimal(0));
			mapper.callProcedure(map);
			System.out.println(map.get("c"));
			System.out.println(map.get("d"));
			session.commit();
		} catch (Exception e) {
			e.printStackTrace();
			session.rollback();
		}
	}

	private static void callFunction() {
		SqlSession session = DBTool.getSession();
		CallMapper mapper = session.getMapper(CallMapper.class);
		try {
			mapper.executeSql("drop table if exists person;");
			mapper.executeSql("create table person(id number,name clob);");
			mapper.executeSql("insert into person values(1.2,'aaa');");
			mapper.executeSql("create or replace function getA(b in varchar(15)) \r\n" + 
					"returns number \r\n" + 
					"as $$\r\n" + 
					"declare \r\n" + 
					"    a number;\r\n" + 
					"begin\r\n" + 
					"    select id into a from person where name=b;\r\n" + 
					"    return a;\r\n" + 
					"end;\r\n" + 
					"$$ language plsql;");
			Map<String, Object> map = new HashMap<String, Object>();
			map.put("b", "aaa");
			mapper.callFunction(map);
			String a = (String) map.get("a");
			System.out.println(map.get("a"));
			session.commit();
		} catch (Exception e) {
			e.printStackTrace();
			session.rollback();
		}
	}
	
	private static void getName() {
		SqlSession session = DBTool.getSession();
		CallMapper mapper = session.getMapper(CallMapper.class);
		try {
//			mapper.executeSql("drop table if exists person;");
//			mapper.executeSql("create table person(id int,name clob);");
//			mapper.executeSql("insert into person values(1,'aaa');");
			mapper.executeSql("create or replace function getName(a in int,b out clob) \r\n" + 
					"as $$\r\n" + 
					"begin\r\n" + 
					"    select name into b from t_user where id = a;\r\n" + 
					"end;\r\n" + 
					"$$ language plsql;");
			
			
			Map<String, Object> map = new HashMap<String, Object>();
			map.put("a", 1);
			UserBean user = new UserBean();
			user.setId(1);
			String name = mapper.getName(user);
//			Clob clob = (Clob) map.get("b");
//			System.out.println(clob.getSubString(1, (int) clob.length()));
			System.out.println(user.getUsername());
			session.commit();
		} catch (Exception e) {
			e.printStackTrace();
			session.rollback();
		}
	}
	
	private static void getTest() {
		SqlSession session = DBTool.getSession();
		CallMapper mapper = session.getMapper(CallMapper.class);
		try {
			Map<String, Object> map = new HashMap<String, Object>();
			map.put("i_ip", 1);
			map.put("i_operuid", 1);
			map.put("i_operunm", 1);
			mapper.getTest(map);
			System.out.println(map.get("o_info"));
			System.out.println(map.get("o_code"));
			System.out.println(map.get("o_msg"));
			session.commit();
		} catch (Exception e) {
			e.printStackTrace();
			session.rollback();
		}
	}
	
	private static void getPerson(String database) {
		SqlSession session = DBTool.getSession();
		CallMapper mapper = session.getMapper(CallMapper.class);
		try {
			if(database.equals("ES")) {
				mapper.executeSql("drop table if exists person;");
				mapper.executeSql("create table person(id int,name clob);");
				mapper.executeSql("insert into person values(1,'aaa');");
				mapper.executeSql("insert into person values(2,'bbb');");
				mapper.executeSql("create or replace procedure getPerson(a int,d out varchar,b out refcursor) \r\n" + 
						"as $$\r\n" + 
						"begin\r\n" + 
						"d := 10.2;" +
						"    open b for select rowid,* from person;\r\n" + 
						"end;\r\n" + 
						"$$ language plsql;");
				mapper.executeSql("create or replace function getPerson2(a varchar, b varchar) returns refcursor \r\n" + 
						"as $$\r\n" + 
						"declare b refcursor;" + 
						"begin\r\n" + 
						"    open b for select rowid,* from person;\r\n" + 
						"    return b;\r\n" + 
						"end;\r\n" + 
						"$$ language plsql;");
			} else if(database.equals("Oracle")) {
				try {
					mapper.executeSql("drop table person");
				} catch(Exception e) {}
				mapper.executeSql("create table person(id int,name clob)");
				mapper.executeSql("insert into person values(1,'aaa')");
				mapper.executeSql("insert into person values(2,'bbb');");
				try {
					mapper.executeSql("drop procedure getPerson");
				} catch(Exception e) {}
				mapper.executeSql("create or replace procedure getPerson(a in numeric,b out sys_refcursor) \r\n" + 
						"as\r\n" + 
						"begin\r\n" + 
						"    open b for select * from person where id = a;\r\n" + 
						"end;");
			}
			
			
//			Map<String, Object> map = new HashMap<String, Object>();
//			map.put("a", 1);
//			map.put("b", 1);
//			map.put("list", new ArrayList<>());
			Map<String, Object> map = mapper.getPerson2(null, null, null);
			ResultSet o = (ResultSet) map.get("getperson2");
			o.next();
			System.out.println(o.getString(1));
			System.out.println(o.getString(2));
			System.out.println(o.getString(3));
//			System.out.println(map.get("param2"));
//			List<Map<String, Object>> list = (List<Map<String, Object>>) map.get("param2");
//			for (Map<String, Object> map2 : list) {
//				RowId id = (RowId) map2.get("rowid");
//				System.out.println(id);
//			}
			
			session.commit();
		} catch (Exception e) {
			e.printStackTrace();
			session.rollback();
		}
	}
	
	

}